﻿using System;
using System.Collections.Generic;
using System.IO;

namespace TestProject
{
    /// <summary>
    /// 프로그램
    /// </summary>
    class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        static void Main()
        {
            // 소스 리스트를 생성한다.
            List<TestData> sourceList = new List<TestData>();
            
            for(int i = 0; i < 1000; i++)
            {
                sourceList.Add(new TestData { ID = i + 1, Name = "항목 " + (i + 1).ToString(), Grade = i % 5 + 1});
            }


            // 파일 스트림에 직렬화 한다.
            FileStream targetFileStream = new FileStream("d:\\result.json", FileMode.CreateNew);

            JSONHelper.Serialize(sourceList, targetFileStream);


            // 파일 스트림에서 역직렬화 한다.
            FileStream sourceFileStream = new FileStream("d:\\a.json", FileMode.Open);

            List<TestData> targetList = JSONHelper.Deserialize<List<TestData>>(sourceFileStream);


            // 결과를 출력한다.
            Console.WriteLine("소스 리스트 : {0}건", sourceList.Count);
            Console.WriteLine("타겟 리스트 : {0}건", targetList.Count);
        }
    }

    #endregion
}